---
title: 'ServiceWorkerGlobalScope: pushsubscriptionchange event'
slug: Web/API/ServiceWorkerGlobalScope/pushsubscriptionchange_event
tags:
  - API
  - Event
  - Push
  - Push API
  - PushSubscriptionChangeEvent
  - Reference
  - Service Workers
  - ServiceWorkerGlobalScope
  - Subscription
---
<div>{{APIRef("Push API")}}</div>

<p><span class="seoSummary">The <strong><code>pushsubscriptionchange</code></strong> event is sent to the <a href="/en-US/docs/Web/API/ServiceWorkerGlobalScope">global scope</a> of a {{domxref("ServiceWorker")}} to indicate a change in push subscription that was triggered outside the application's control.</span> This may occur if the subscription was refreshed by the browser, but it may also happen if the subscription has been revoked or lost.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("PushSubscriptionChangeEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{domxref("ServiceWorkerGlobalScope.onpushsubscriptionchange", "onpushsubscriptionchange")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Usage_notes">Usage notes</h2>

<p>Although examples demonstrating how to share subscription related information with the application server tend to use {{domxref("WindowOrWorkerGlobalScope.fetch", "fetch()")}}, this is not necessarily the best choice for real-world use, since it will not work if the app is offline, for example.</p>

<p>Consider using another method to synchronize subscription information between your service worker and the app server, or make sure your code using <code>fetch()</code> is robust enough to handle cases where attempts to exchange data fail.</p>

<div class="notecard note">
<p><strong>Note:</strong> In earlier drafts of the specification, this event was defined to be sent when a {{domxref("PushSubscription")}} has expired.</p>
</div>

<h2 id="Examples">Examples</h2>

<p>This example, run in the context of a service worker, listens for a <code>pushsubscriptionchange</code> event and re-subscribes to the lapsed subscription.</p>

<pre class="brush: js notranslate">self.addEventListener("pushsubscriptionchange", event =&gt; {
  event.waitUntil(swRegistration.pushManager.subscribe(event.oldSubscription.options)
    .then(subscription =&gt; {
      return fetch("register", {
        method: "post",
        headers: {
          "Content-type": "application/json"
        },
        body: JSON.stringify({
          endpoint: subscription.endpoint
        })
      });
    })
  );
}, false);</pre>

<p>When a <code>pushsubscriptionchange</code> event arrives, indicating that the subscription has expired, we resubscribe by calling the push manager's {{domxref("PushManager.subscribe", "subscribe()")}} method. When the returned promise is resolved, we receive the new subscription. This is delivered to the app server using a {{domxref("WindowOrWorkerGlobalScope.fetch", "fetch()")}} call to post a {{Glossary("JSON")}} formatted rendition of the subscription's {{domxref("PushSubscription.endpoint", "endpoint")}} to the app server.</p>

<p>You can also use the {{domxref("ServiceWorkerGlobalScope.onpushsubscriptionchange", "onpushsubscriptionchange")}} event handler property to set up the event handler:</p>

<pre class="brush: js notranslate">self.onpushsubscriptionchange = event =&gt; {
  event.waitUntil(swRegistration.pushManager.subscribe(event.oldSubscription.options)
    .then(subscription =&gt; {
      /* ... */
    )
};</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Push API', '#the-pushsubscriptionchange-event', 'pushsubscriptionchange')}}</td>
   <td>{{Spec2('Push API')}}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ServiceWorkerGlobalScope.pushsubscriptionchange_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Push_API/Using_the_Push_API">Using the Push API</a></li>
 <li>{{domxref("ServiceWorkerGlobalScope.onpushsubscriptionchange", "onpushsubscriptionchange")}} event handler property</li>
</ul>
